<?php
/*
Plugin Name: Facebook Dashboard Widget
Plugin URI: http://mou.me.uk/projects/wordpress/plugins/facebook-dashboard-widget/
Description: Display your friends latest status updates, posted items and/or notifications on your WordPress dashboard or blog sidebar (check your widgets page).  Make sure you enter your feed details on <a href="options-general.php?page=facebook-dashboard-widget/fdw.php">the options page</a>.
Version: 0.9.9
Author: Chris Chrisostomou
Author URI: http://mou.me.uk/
*/

// **********************************************************************
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
// **********************************************************************

// Changelog:
// 0.9.9	- Fixed issue with posted items comments not showing, updated readme, new screenshot
// 0.9.8	- Sidebar widgets added
// 0.9.5	- Height settings available for pre & post WP 2.7
// 0.9.1	- WordPress 2.7 compatibility
// 0.9		- Added posted items, fixed some issues with readme file
// 0.8.1	- Added support for Dashboard Widget Manager
// 0.8		- Beta release  (20/4/08)


// Add the default options on plugin activation (if they don't already exist)
register_activation_hook(__FILE__, fdw_init);
function fdw_init() {
	if ( get_option('fdw_showupdates')					== "" ) { add_option("fdw_showupdates", $value = "no", $deprecated = "", $autoload = "yes"); }
	if ( get_option('fdw_updatesfeed')					== "" ) { add_option("fdw_updatesfeed", $value = "", $deprecated = "", $autoload = "yes"); }
	if ( get_option('fdw_updatesmax')					== "" ) { add_option("fdw_updatesmax", $value = "5", $deprecated = "", $autoload = "yes"); }
	if ( get_option('fdw_updatesnewheight')				== "" ) { add_option("fdw_updatesnewheight", $value = "full", $deprecated = "", $autoload = "yes"); }
	if ( get_option('fdw_updatesheight')				== "" ) { add_option("fdw_updatesheight", $value = "single", $deprecated = "", $autoload = "yes"); }
	if ( get_option('fdw_updateswidth')					== "" ) { add_option("fdw_updateswidth", $value = "half", $deprecated = "", $autoload = "yes"); }
	
	if ( get_option('fdw_shownotifications')			== "" ) { add_option("fdw_shownotifications", $value = "no", $deprecated = "", $autoload = "yes"); }
	if ( get_option('fdw_notificationsfeed')			== "" ) { add_option("fdw_notificationsfeed", $value = "", $deprecated = "", $autoload = "yes"); }
	if ( get_option('fdw_notificationsmax')				== "" ) { add_option("fdw_notificationsmax", $value = "5", $deprecated = "", $autoload = "yes"); }
	if ( get_option('fdw_notificationsnewheight')		== "" ) { add_option("fdw_notificationsnewheight", $value = "full", $deprecated = "", $autoload = "yes"); }
	if ( get_option('fdw_notificationsheight')			== "" ) { add_option("fdw_notificationsheight", $value = "single", $deprecated = "", $autoload = "yes"); }
	if ( get_option('fdw_notificationswidth')			== "" ) { add_option("fdw_notificationswidth", $value = "half", $deprecated = "", $autoload = "yes"); }
	
	if ( get_option('fdw_showposted')					== "" ) { add_option("fdw_showposted", $value = "no", $deprecated = "", $autoload = "yes"); }
	if ( get_option('fdw_postedfeed')					== "" ) { add_option("fdw_postedfeed", $value = "", $deprecated = "", $autoload = "yes"); }
	if ( get_option('fdw_postedmax')					== "" ) { add_option("fdw_postedmax", $value = "5", $deprecated = "", $autoload = "yes"); }
	if ( get_option('fdw_postednewheight')				== "" ) { add_option("fdw_postednewheight", $value = "full", $deprecated = "", $autoload = "yes"); }
	if ( get_option('fdw_postedheight')					== "" ) { add_option("fdw_postedheight", $value = "single", $deprecated = "", $autoload = "yes"); }
	if ( get_option('fdw_postedwidth')					== "" ) { add_option("fdw_postedwidth", $value = "half", $deprecated = "", $autoload = "yes"); }
	
	if ( get_option('fdw_widget_updatesoptions')		== "" ) { add_option("fdw_widget_updatesoptions", $value = array("title"=>"Facebook Friends Updates", "num"=>"5"), $deprecated = "", $autoload = "yes"); }
	if ( get_option('fdw_widget_notificationsoptions')	== "" ) { add_option("fdw_widget_notificationsoptions", $value = array("title"=>"Facebook Notifications", "num"=>"5"), $deprecated = "", $autoload = "yes"); }
	if ( get_option('fdw_widget_posteditemsoptions')	== "" ) { add_option("fdw_widget_posteditemsoptions", $value = array("title"=>"Facebook Posted Items", "num"=>"5"), $deprecated = "", $autoload = "yes"); }
	
}

$fdw = new fdw;

class fdw {
	
	var $updates_show;
	var $updates_feed;
	var $updates_max;
	var $updates_height;
	var $updates_new_height;
	var $updates_width;
	var $notifications_show;
	var $notifications_feed;
	var $notifications_max;
	var $notifications_height;
	var $notifications_new_height;
	var $notifications_width;
	var $posted_show;
	var $posted_feed;
	var $posted_max;
	var $posted_height;
	var $posted_new_height;
	var $posted_width;
	
	function fdw() {
		$this -> updates_show = get_option('fdw_showupdates');
		$this -> updates_feed = get_option('fdw_updatesfeed');
		$this -> updates_max = get_option('fdw_updatesmax');
		$this -> updates_height = get_option('fdw_updatesheight');
		$this -> updates_new_height = get_option('fdw_updatesnewheight');
		$this -> updates_width = get_option('fdw_updateswidth');
		$this -> notifications_show = get_option('fdw_shownotifications');
		$this -> notifications_feed = get_option('fdw_notificationsfeed');
		$this -> notifications_max = get_option('fdw_notificationsmax');
		$this -> notifications_height = get_option('fdw_notificationsheight');
		$this -> notifications_new_height = get_option('fdw_notificationsnewheight');
		$this -> notifications_width = get_option('fdw_notificationswidth');
		$this -> posted_show = get_option('fdw_showposted');
		$this -> posted_feed = get_option('fdw_postedfeed');
		$this -> posted_max = get_option('fdw_postedmax');
		$this -> posted_height = get_option('fdw_postedheight');
		$this -> posted_new_height = get_option('fdw_postednewheight');
		$this -> posted_width = get_option('fdw_postedwidth');
		if	( 	$this -> updates_show == "" || 
				$this -> updates_max == "" || 
				$this -> updates_height == "" || 
				$this -> updates_new_height == "" || 
				$this -> updates_width == "" || 
				$this -> notifications_show == "" || 
				$this -> notifications_max == "" || 
				$this -> notifications_height == "" || 
				$this -> notifications_new_height == "" || 
				$this -> notifications_width == "" || 
				$this -> posted_show == "" || 
				$this -> posted_max == "" || 
				$this -> posted_height == "" || 
				$this -> posted_new_height == "" || 
				$this -> posted_width == ""	|| 
				get_option('fdw_widget_updatesoptions') == "" || 
				get_option('fdw_widget_notificationsoptions') == "" || 
				get_option('fdw_widget_posteditemsoptions') == ""
		) {
			fdw_init();
		}
	}
	
	function get_statuses($mode="dashboard", $count=false) {
		global $fdw;
		$count = ($count===false) ? $this->updates_max : $count;
		require_once( ABSPATH . WPINC . '/rss.php' );
		$rss = @ fetch_rss($this->updates_feed);
		if ($rss) {
			$items = array_slice($rss->items, 0, $count);
			echo '<ul';
			if ((float) $GLOBALS['wp_version'] >= 2.7 && is_numeric($this->updates_new_height) && $mode=="dashboard") echo ' style="height:' . $this->updates_new_height . 'px; overflow:auto;"';
			echo ' class="fdw_widget">';
			foreach ( $items as $item ) {
				echo '<li><span><a href="' . $item['link'] . '" class="rsswidget">' . $item['title'] . '</a></span><br /><span style="color:#999999; font-family:"Lucida Grande",Verdana,Arial,"Bitstream Vera Sans",sans-serif; font-size:11px;">' . $this -> when_posted($item['pubdate']) . '</span></li>';
			}
			echo '</ul>';
		} else {
			if ( $this->updates_feed == "" ) {
				echo  '<p>You need to enter your Facebook feed URL in order to grab your status updates!</p>';
			} else {
				echo '<p>We\'re unable to grab your Facebook feed at this time.  Are you sure you\'ve entered it correctly?</p>';
			}
			echo  '<p>Check <a href="options-general.php?page=facebook-dashboard-widget/fdw.php">the options page</a> for more information.</p>';
		}
	}
	
	function get_notifications($mode="dashboard", $count=false) {
		global $fdw;
		$count = ($count===false) ? $this->notifications_max : $count;
		require_once( ABSPATH . WPINC . '/rss.php' );
		$rss = @ fetch_rss($this->notifications_feed);
		if ($rss) {
			$items = array_slice($rss->items, 0, $count);
			echo '<ul';
			if ((float) $GLOBALS['wp_version'] >= 2.7 && is_numeric($this->notifications_new_height) && $mode=="dashboard") echo ' style="height:' . $this->notifications_new_height . 'px; overflow:auto;"';
			echo ' class="fdw_widget">';
			foreach ( $items as $item ) {
				echo '<li><span><a href="' . $item['link'] . '" class="rsswidget">' . $item['title'] . '</a></span><br /><span style="color:#999999; font-family:"Lucida Grande",Verdana,Arial,"Bitstream Vera Sans",sans-serif; font-size:11px;">' . $this -> when_posted($item['pubdate']) . '</span></li>';
			}
			echo '</ul>';
			
			
		} else {
			if ( $this->posted_feed == "" ) {
				echo  '<p>You need to enter your Facebook feed URL in order to grab your latest posted items!</p>';
			} else {
				echo '<p>We\'re unable to grab your Facebook feed at this time.  Are you sure you\'ve entered it correctly?</p>';
			}
			echo  '<p>Check <a href="options-general.php?page=facebook-dashboard-widget/fdw.php">the options page</a> for more information.</p>';
		}
	}
	
	function get_posteditems($mode="dashboard", $count=false) {
		global $fdw;
		$count = ($count===false) ? $this->posted_max : $count;
		require_once( ABSPATH . WPINC . '/rss.php' );
		$rss = @ fetch_rss($this->posted_feed);
		if ($rss) {
			$items = array_slice($rss->items, 0, $count);
			echo '<ul';
			if ((float) $GLOBALS['wp_version'] >= 2.7 && is_numeric($this->posted_new_height) && $mode=="dashboard") echo ' style="height:' . $this->posted_new_height . 'px; overflow:auto;"';
			echo ' class="fdw_widget">';
			foreach ( $items as $item ) {
				$description = preg_match('/<div class="summary">(.*)<\/div><\/div><div class="owner_comment">/', html_entity_decode($item['description']), $desc);
				$extracomment = preg_match('/<span class="story_comment">(.*)<\/span><span class="end_quote">/', html_entity_decode($item['description']), $comment);
				echo '<li>';
					echo '<span><a href="' . $item['link'] . '" class="rsswidget">' . $item['title'] . '</a></span><br />';
					if ( $description == true ) {
						echo $desc[1] . "<br />";
					}
					if ( $extracomment == true ) {
						echo '"' . $comment[1] . '"';
					}
					echo '<span style="color:#999999; font-family:"Lucida Grande",Verdana,Arial,"Bitstream Vera Sans",sans-serif; font-size:11px;"> - posted ' . $this -> when_posted($item['pubdate']) . ' by ' . $item['author'] . '</span>';
				echo '</li>';
			}
			echo '</ul>';
			
			
		} else {
			if ( $this->notifications_feed == "" ) {
				echo  '<p>You need to enter your Facebook feed URL in order to grab your status updates!</p>';
			} else {
				echo '<p>We\'re unable to grab your Facebook feed at this time.  Are you sure you\'ve entered it correctly?</p>';
			}
			echo  '<p>Check <a href="options-general.php?page=facebook-dashboard-widget/fdw.php">the options page</a> for more information.</p>';
		}
	}
	
	function when_posted($pubdate) {
		$a = "";
		$pubdate = strtotime($pubdate);
		$now = time();
		$difference = $now - $pubdate;
		
		$days = floor($difference / 84600);
		$difference -= 84600 * floor($difference / 84600);
		
		$hours = floor($difference / 3600);
		$difference -= 3600 * floor($difference / 3600);
		
		$minutes .= floor($difference / 60);
		$seconds = $difference - (60 * floor($difference / 60));
		
		if ( $days > 0 ) {
			$a .= $days . " day";
			if ( $day > 1 ) {
				echo "s";
			}
			$a .= " ago";
			return $a;
		}
		if ( $hours > 0 ) {
			$a .= $hours . " hour";
			if ( $hours > 1 ) {
				$a .= "s";
			}			
			if ($hours > 2) {
				$a .= " ago";
				return $a;
			} else {
				$a .= ", ";
			}
		}
		if ( $minutes > 0 ) {
			$a .= $minutes . " minute";
			if ( $minutes > 1 ) {
				$a .= "s";
			}
			if ( $minutes > 2 ) {
				$a .= " ago";
				return $a;
			} else {
				$a .= ", ";
			}
		}
		$a .= $seconds . " seconds ago";	
		return $a;
	}
	
}

if ( $fdw -> updates_show == "yes" ) {
	add_action('wp_dashboard_setup', 'fdw_updates_register_dashboard_widget');
	add_filter('wp_dashboard_widgets', 'fdw_updates_add_dashboard_widget');
}

if ( $fdw -> notifications_show == "yes" ) {
	add_action('wp_dashboard_setup', 'fdw_notifications_register_dashboard_widget');
	add_filter('wp_dashboard_widgets', 'fdw_notifications_add_dashboard_widget');
}

if ( $fdw -> posted_show == "yes" ) {
	add_action('wp_dashboard_setup', 'fdw_posted_register_dashboard_widget');
	add_filter('wp_dashboard_widgets', 'fdw_posted_add_dashboard_widget');
}


### Function: Register Dashboard Widget
function fdw_updates_register_dashboard_widget() {
	global $fdw;
	wp_register_sidebar_widget('dashboard_fdw_updates', __('Facebook Friends Status Updates', 'fdw_updates'), 'dashboard_fdw_updates',
		array(
		'all_link' => 'http://www.facebook.com/friends/',
		'feed_link' => $fdw -> updates_feed,
		'width' => $fdw -> updates_width,
		'height' => $fdw -> updates_height,
		)
	);
}

function fdw_notifications_register_dashboard_widget() {
	global $fdw;
	wp_register_sidebar_widget('dashboard_fdw_notifications', __('Facebook Notifications', 'fdw_notifications'), 'dashboard_fdw_notifications',
		array(
		'all_link' => 'http://www.facebook.com/friends',
		'feed_link' => $fdw -> notifications_feed,
		'width' => $fdw -> notifications_width,
		'height' => $fdw -> notifications_height,
		)
	);
}

function fdw_posted_register_dashboard_widget() {
	global $fdw;
	wp_register_sidebar_widget('dashboard_fdw_posted', __('Facebook Friends Posted Items', 'fdw_posted'), 'dashboard_fdw_posted',
		array(
		'all_link' => 'http://www.facebook.com/posted.php',
		'feed_link' => $fdw -> posted_feed,
		'width' => $fdw -> posted_width,
		'height' => $fdw -> posted_height,
		)
	);
}

 
// Add Dashboard Widget
function fdw_updates_add_dashboard_widget($widgets) {
	global $wp_registered_widgets;
	if (!isset($wp_registered_widgets['dashboard_fdw_updates'])) {
		return $widgets;
	}
	array_splice($widgets, sizeof($widgets)-1, 0, 'dashboard_fdw_updates');
	return $widgets;
}
function fdw_notifications_add_dashboard_widget($widgets) {
	global $wp_registered_widgets;
	if (!isset($wp_registered_widgets['dashboard_fdw_notifications'])) {
		return $widgets;
	}
	array_splice($widgets, sizeof($widgets)-1, 0, 'dashboard_fdw_notifications');
	return $widgets;
}
function fdw_posted_add_dashboard_widget($widgets) {
	global $wp_registered_widgets;
	if (!isset($wp_registered_widgets['dashboard_fdw_posted'])) {
		return $widgets;
	}
	array_splice($widgets, sizeof($widgets)-1, 0, 'dashboard_fdw_posted');
	return $widgets;
}
 
// Display Updates Dashboard Widget
function dashboard_fdw_updates($sidebar_args) {
	global $wpdb, $fdw;
	
	if (is_array($sidebar_args)) extract($sidebar_args, EXTR_SKIP);
	echo $before_widget;
	echo $before_title;
	echo $widget_name;
	echo $after_title;
	$fdw -> get_statuses();
	echo $after_widget;
}

// Display Notifications Dashboard Widget
function dashboard_fdw_notifications($sidebar_args) {
	global $wpdb, $fdw;
	
	if (is_array($sidebar_args)) extract($sidebar_args, EXTR_SKIP);
	echo $before_widget;
	echo $before_title;
	echo $widget_name;
	echo $after_title;
	$fdw -> get_notifications();
	echo $after_widget;
}

// Display Posted Items Dashboard Widget
function dashboard_fdw_posted($sidebar_args) {
	global $wpdb, $fdw;
	
	if (is_array($sidebar_args)) extract($sidebar_args, EXTR_SKIP);
	echo $before_widget;
	echo $before_title;
	echo $widget_name;
	echo $after_title;
	$fdw -> get_posteditems();
	echo $after_widget;
}

// Options Page
function fdw_options() {
	global $fdw;
	$wpVersion = (float) $GLOBALS['wp_version'];
	?>
    <div class="wrap">
    		
		<form method="post" action="options.php" style="margin-bottom: 60px;">
			<h2><?php echo __('Facebook Dashboard Widget Options', 'fdw') ?></h2>
			<?php wp_nonce_field('update-options') ?>
			
			<h3>Friends Status Updates</h3>
			<table class="form-table" style="margin: 5px 0 20px;">
				<tr>
					<th>Display Status Updates Widget?</th>
					<td>
						<select name="fdw_showupdates">
							<option value="no"<?php if ( $fdw->updates_show == "no" ) { echo ' selected="selected"'; } ?>>No</option>
							<option value="yes"<?php if ( $fdw->updates_show == "yes" ) { echo ' selected="selected"'; } ?>>Yes</option>
						</select>
						 <em>Make sure you enter your feed URL before activating - for more information on how, <a href="#updates">see below</a></em>
					</td>
				</tr>
				<tr>
					<th>Status Updates Feed URL:</th>
					<td><input type="text" name="fdw_updatesfeed" value="<?php echo $fdw->updates_feed; ?>" size="105" /> <a href="#updates">?</a></td>
				</tr>
				<tr>
					<th>Number of updates to show:</th>
					<td>
						<select name="fdw_updatesmax">
							<?php
							for ($a=5; $a<=30; $a++) {
								echo '<option value="' . $a . '"';
								if ( $a == $fdw->updates_max ) {
									echo ' selected="selected"';
								}
								echo '>' . $a . '</option>';
							}
							?>
						</select>
					</td>
				</tr>
				<tr<?php if ($wpVersion < 2.7) echo ' style="display:none;"'; ?>>
					<th>Widget Height:</th>
					<td>
						<select name="fdw_updatesnewheight">
							<option value="full"<?php if ( $fdw->updates_new_height == "full" ) { echo ' selected="selected"'; } ?>>Full</option>
							<option value="200"<?php if ( $fdw->updates_new_height == "200" ) { echo ' selected="selected"'; } ?>>200 Pixels</option>
							<option value="300"<?php if ( $fdw->updates_new_height == "300" ) { echo ' selected="selected"'; } ?>>300 Pixels</option>
							<option value="400"<?php if ( $fdw->updates_new_height == "400" ) { echo ' selected="selected"'; } ?>>400 Pixels</option>
							<option value="500"<?php if ( $fdw->updates_new_height == "500" ) { echo ' selected="selected"'; } ?>>500 Pixels</option>
							<option value="750"<?php if ( $fdw->updates_new_height == "750" ) { echo ' selected="selected"'; } ?>>750 Pixels</option>
						</select>
					</td>
				</tr>
				<tr<?php if ($wpVersion >= 2.7) echo ' style="display:none;"'; ?>>
					<th>Widget Height:</th>
					<td>
						<select name="fdw_updatesheight">
							<option value="single"<?php if ( $fdw->updates_height == "single" ) { echo ' selected="selected"'; } ?>>Single</option>
							<option value="double"<?php if ( $fdw->updates_height == "double" ) { echo ' selected="selected"'; } ?>>Double</option>
						</select>
					</td>
				</tr>
				<tr<?php if ($wpVersion >= 2.7) echo ' style="display:none;"'; ?>>
					<th>Widget Width:</th>
					<td>
						<select name="fdw_updateswidth">
							<option value="half"<?php if ( $fdw->updates_width == "half" ) { echo ' selected="selected"'; } ?>>Single</option>
							<option value="full"<?php if ( $fdw->updates_width == "full" ) { echo ' selected="selected"'; } ?>>Double</option>
						</select>
					</td>
				</tr>
			</table>
			
			<h3>Notifications</h3>
			<table class="form-table" style="margin: 5px 0;">
				<tr>
					<th>Display Notifications Widget?</th>
					<td>
						<select name="fdw_shownotifications">
							<option value="no"<?php if ( $fdw->notifications_show == "no" ) { echo ' selected="selected"'; } ?>>No</option>
							<option value="yes"<?php if ( $fdw->notifications_show == "yes" ) { echo ' selected="selected"'; } ?>>Yes</option>
						</select>
						 <em>Make sure you enter your feed URL before activating - for more information on how, <a href="#notifications">see below</a></em>
					</td>
				</tr>
				<tr>
					<th>Status Notifications Feed URL:</th>
					<td><input type="text" name="fdw_notificationsfeed" value="<?php echo $fdw->notifications_feed; ?>" size="105" /> <a href="#notifications">?</a></td>
				</tr>
				<tr>
					<th>Number of updates to show:</th>
					<td>
						<select name="fdw_notificationsmax">
							<?php
							for ($b=5; $b<=10; $b++) {
								echo '<option value="' . $b . '"';
								if ( $b == $fdw->notifications_max ) {
									echo ' selected="selected"';
								}
								echo '>' . $b . '</option>';
							}
							?>
						</select>
					</td>
				</tr>
				<tr<?php if ($wpVersion < 2.7) echo ' style="display:none;"'; ?>>
					<th>Widget Height:</th>
					<td>
						<select name="fdw_notificationsnewheight">
							<option value="full"<?php if ( $fdw->notifications_new_height == "full" ) { echo ' selected="selected"'; } ?>>Full</option>
							<option value="200"<?php if ( $fdw->notifications_new_height == "200" ) { echo ' selected="selected"'; } ?>>200 Pixels</option>
							<option value="300"<?php if ( $fdw->notifications_new_height == "300" ) { echo ' selected="selected"'; } ?>>300 Pixels</option>
							<option value="400"<?php if ( $fdw->notifications_new_height == "400" ) { echo ' selected="selected"'; } ?>>400 Pixels</option>
							<option value="500"<?php if ( $fdw->notifications_new_height == "500" ) { echo ' selected="selected"'; } ?>>500 Pixels</option>
							<option value="750"<?php if ( $fdw->notifications_new_height == "750" ) { echo ' selected="selected"'; } ?>>750 Pixels</option>
						</select>
					</td>
				</tr>
				<tr<?php if ($wpVersion >= 2.7) echo ' style="display:none;"'; ?>>
					<th>Widget Height:</th>
					<td>
						<select name="fdw_notificationsheight">
							<option value="single"<?php if ( $fdw->notifications_height == "single" ) { echo ' selected="selected"'; } ?>>Single</option>
							<option value="double"<?php if ( $fdw->notifications_height == "double" ) { echo ' selected="selected"'; } ?>>Double</option>
						</select>
					</td>
				</tr>
				<tr<?php if ($wpVersion >= 2.7) echo ' style="display:none;"'; ?>>
					<th>Widget Width:</th>
					<td>
						<select name="fdw_notificationswidth">
							<option value="half"<?php if ( $fdw->notifications_width == "half" ) { echo ' selected="selected"'; } ?>>Single</option>
							<option value="full"<?php if ( $fdw->notifications_width == "full" ) { echo ' selected="selected"'; } ?>>Double</option>
						</select>
					</td>
				</tr>
			</table>
			
			<h3>Posted Items</h3>
			<table class="form-table" style="margin: 5px 0;">
				<tr>
					<th>Display Posted Items Widget?</th>
					<td>
						<select name="fdw_showposted">
							<option value="no"<?php if ( $fdw->posted_show == "no" ) { echo ' selected="selected"'; } ?>>No</option>
							<option value="yes"<?php if ( $fdw->posted_show == "yes" ) { echo ' selected="selected"'; } ?>>Yes</option>
						</select>
						 <em>Make sure you enter your feed URL before activating - for more information on how, <a href="#posted">see below</a></em>
					</td>
				</tr>
				<tr>
					<th>Posted Items Feed URL:</th>
					<td><input type="text" name="fdw_postedfeed" value="<?php echo $fdw->posted_feed; ?>" size="105" /> <a href="#posted">?</a></td>
				</tr>
				<tr>
					<th>Number of updates to show:</th>
					<td>
						<select name="fdw_postedmax">
							<?php
							for ($b=5; $b<=30; $b++) {
								echo '<option value="' . $b . '"';
								if ( $b == $fdw->posted_max ) {
									echo ' selected="selected"';
								}
								echo '>' . $b . '</option>';
							}
							?>
						</select>
					</td>
				</tr>
				<tr<?php if ($wpVersion < 2.7) echo ' style="display:none;"'; ?>>
					<th>Widget Height:</th>
					<td>
						<select name="fdw_postednewheight">
							<option value="full"<?php if ( $fdw->posted_new_height == "full" ) { echo ' selected="selected"'; } ?>>Full</option>
							<option value="200"<?php if ( $fdw->posted_new_height == "200" ) { echo ' selected="selected"'; } ?>>200 Pixels</option>
							<option value="300"<?php if ( $fdw->posted_new_height == "300" ) { echo ' selected="selected"'; } ?>>300 Pixels</option>
							<option value="400"<?php if ( $fdw->posted_new_height == "400" ) { echo ' selected="selected"'; } ?>>400 Pixels</option>
							<option value="500"<?php if ( $fdw->posted_new_height == "500" ) { echo ' selected="selected"'; } ?>>500 Pixels</option>
							<option value="750"<?php if ( $fdw->posted_new_height == "750" ) { echo ' selected="selected"'; } ?>>750 Pixels</option>
						</select>
					</td>
				</tr>
				<tr<?php if ($wpVersion >= 2.7) echo ' style="display:none;"'; ?>>
					<th>Widget Height:</th>
					<td>
						<select name="fdw_postedheight">
							<option value="single"<?php if ( $fdw->posted_height == "single" ) { echo ' selected="selected"'; } ?>>Single</option>
							<option value="double"<?php if ( $fdw->posted_height == "double" ) { echo ' selected="selected"'; } ?>>Double</option>
						</select>
					</td>
				</tr>
				<tr<?php if ($wpVersion >= 2.7) echo ' style="display:none;"'; ?>>
					<th>Widget Width:</th>
					<td>
						<select name="fdw_postedwidth">
							<option value="half"<?php if ( $fdw->posted_width == "half" ) { echo ' selected="selected"'; } ?>>Single</option>
							<option value="full"<?php if ( $fdw->posted_width == "full" ) { echo ' selected="selected"'; } ?>>Double</option>
						</select>
					</td>
				</tr>
			</table>
            <input type="hidden" name="action" value="update" />
            <input type="hidden" name="page_options" value="fdw_showupdates, fdw_updatesfeed, fdw_updatesmax, fdw_updatesheight, fdw_updatesnewheight, fdw_updateswidth, fdw_shownotifications, fdw_notificationsfeed, fdw_notificationsmax, fdw_notificationsheight, fdw_notificationsnewheight, fdw_notificationswidth, fdw_showposted, fdw_postedfeed, fdw_postedmax, fdw_postedheight, fdw_postednewheight, fdw_postedwidth" />
            <p class="submit"><input type="submit" name="Submit" value="<?php _e('Update Options »') ?>" /></p>
	    </form>
	
		<h2><a name="updates"></a>How to find your Status Updates feed</h2>
		<p><span style="font-size: 24px; font-weight: bold;">1. </span> Log into facebook, and click the "Friends" tab at the top of your page (as below)</p>
		<img src="<?php echo bloginfo('wpurl'); ?>/wp-content/plugins/facebook-dashboard-widget/images/updates-1.gif" />
		<p><span style="font-size: 24px; font-weight: bold;">2.</span> Look at the bottom of the left hand sidebar for a link marked "Friends' Status Feed".</p>
		<p><span style="font-size: 24px; font-weight: bold;">3.</span> Right click on the link, and select "Copy Link Location" (if you're using Firefox) or "Copy Shortcut" (if you're using Internet Explorer).  The link can now be pasted into the box on the form at the top of this page.</p>
		<img src="<?php echo bloginfo('wpurl'); ?>/wp-content/plugins/facebook-dashboard-widget/images/updates-2.gif" />
		
		<h2 style="margin-top: 30px;"><a name="notifications"></a>How to find your notifications feed</h2>
		<p><span style="font-size: 24px; font-weight: bold;">1. </span> Log into facebook, click the arrow next to the "Inbox" tab at the top of your page and select the "Notifications" option from the drop down menu (as below)</p>
		<img src="<?php echo bloginfo('wpurl'); ?>/wp-content/plugins/facebook-dashboard-widget/images/notifications-1.gif" />
		<p><span style="font-size: 24px; font-weight: bold;">2.</span> Click the tab marked "Notifications".</p>
		<img src="<?php echo bloginfo('wpurl'); ?>/wp-content/plugins/facebook-dashboard-widget/images/notifications-2.gif" />
		<p><span style="font-size: 24px; font-weight: bold;">3.</span>Look in the right hand sidebar for a link named "Your Notifications".  Right click on the link, and select "Copy Link Location" (if you're using Firefox) or "Copy Shortcut" (if you're using Internet Explorer).  The link can now be pasted into the box on the form at the top of this page.</p>
		<img src="<?php echo bloginfo('wpurl'); ?>/wp-content/plugins/facebook-dashboard-widget/images/notifications-3.gif" />
		
		<h2 style="margin-top: 30px;"><a name="posted"></a>How to find your friends posted items feed</h2>
		<p><span style="font-size: 24px; font-weight: bold;">1. </span> Go to <a href="http://www.facebook.com/posted.php" target="_blank">http://www.facebook.com/posted.php</a> (you may need to log in if you haven't already)</p>
		<p><span style="font-size: 24px; font-weight: bold;">2.</span> Look on the right hand sidebar for a link marked "My Friends' Posted Items".</p>
		<p><span style="font-size: 24px; font-weight: bold;">3.</span> Right click on the link, and select "Copy Link Location" (if you're using Firefox) or "Copy Shortcut" (if you're using Internet Explorer).  The link can now be pasted into the box on the form at the top of this page.</p>
		
		<h2 style="margin-top: 60px;"><a name="donate"></a>Donate</h2>
		<p>This plugin is provided free under a GPL license, which means you can use, share, alter, change and generally mess around with to your hearts content -   and completely for free!  But if you like this plugin and would like to throw £1 or £2 my way, it'd take some of the strain away from spending entire weekends in front of my laptop  ;o)</p>
		<p>But whether you choose to donate or not, I hope you enjoy the plugin!</p>
		<form name="_xclick" action="https://www.paypal.com/cgi-bin/webscr" method="post" target="_blank">
		<input type="hidden" name="cmd" value="_xclick">
		<input type="hidden" name="business" value="cezuk@aol.com">
		<input type="hidden" name="item_name" value="FDW Donation">
		<input type="hidden" name="currency_code" value="GBP">
		<input type="hidden" name="amount" value="1.00">
		<input type="image" src="http://www.paypal.com/en_US/i/btn/btn_donate_LG.gif" border="0" name="submit" alt="Make payments with PayPal - it's fast, free and secure!" style="margin-bottom:-5px;"> £1.00
		</form>
		<form name="_xclick" action="https://www.paypal.com/cgi-bin/webscr" method="post" target="_blank">
		<input type="hidden" name="cmd" value="_xclick">
		<input type="hidden" name="business" value="cezuk@aol.com">
		<input type="hidden" name="item_name" value="FDW Donation">
		<input type="hidden" name="currency_code" value="GBP">
		<input type="image" src="http://www.paypal.com/en_US/i/btn/btn_donate_LG.gif" border="0" name="submit" alt="Make payments with PayPal - it's fast, free and secure!" style="margin:0 0 -8px;">
		£<input type="text" name="amount" value="" size="20">
		</form>
	</div>
    <?php
}

function fdw_menus() {
	if (current_user_can('manage_options')) {
		if (function_exists('add_options_page')) {
			add_options_page(__('Facebook Dashboard Widget', 'fdw'), __('Facebook Dashboard Widget', 'fdw'), 8, __FILE__, 'fdw_options');
		}
	}
}

add_action('admin_menu', 'fdw_menus');


// Sidebar widget controls
function fdw_sidebar() {
	if ( !function_exists('register_sidebar_widget') )
			return;
	
	function fdw_updates_sidebar_widget() {
		$options = get_option('fdw_widget_updatesoptions');
		echo $before_widget;
		echo '<li id="widget facebook-widget">';
		echo sprintf('<h3 class="widgettitle">%s</h3>', $options['title']);
		$fdw = new fdw();
		$fdw->get_statuses("sidebar", $options['num']);
		echo '</li>';
		echo $after_widget;
	}
	register_sidebar_widget('Facebook Status Updates', 'fdw_updates_sidebar_widget');
	
	function fdw_notifications_sidebar_widget() {
		$options = get_option('fdw_widget_notificationsoptions');
		echo $before_widget;
		echo '<li id="widget facebook-widget">';
		echo sprintf('<h3 class="widgettitle">%s</h3>', $options['title']);
		$fdw = new fdw();
		$fdw->get_notifications("sidebar", $options['num']);
		echo '</li>';
		echo $after_widget;
	}
	register_sidebar_widget('Facebook Notifications', 'fdw_notifications_sidebar_widget');
	
	function fdw_posteditems_sidebar_widget() {
		$options = get_option('fdw_widget_posteditemsoptions');
		echo $before_widget;
		echo '<li id="widget facebook-widget">';
		echo sprintf('<h3 class="widgettitle">%s</h3>', $options['title']);
		$fdw = new fdw();
		$fdw->get_posteditems("sidebar", $options['num']);
		echo '</li>';
		echo $after_widget;
	}
	register_sidebar_widget('Facebook Posted Items', 'fdw_posteditems_sidebar_widget');
	
	function fdw_updates_widget_control() {
		$options = get_option('fdw_widget_updatesoptions');
		if (!is_array($options)) {
			$options = array(
				'title'	=> 'Facebook Friends Updates',
				'num'	=> '5'
			);
		}
		if (isset($_POST['fdw_widget_updatesoptions_action']) && $_POST['fdw_widget_updatesoptions_action'] == 'fdw_widget_updatesoptions_update_widget_options') {
			$options['title']	= sprintf('%s', $_POST['fdw_widget_updatesoptions_widget_title']);
			$options['num']		= sprintf('%d', $_POST['fdw_widget_updatesoptions_widget_num']);
			update_option('fdw_widget_updatesoptions', $options);
		}
		
		$title	= $options['title'];
		$num	= $options['num'];
		print('
			<p style="text-align:right;"><label for="fdw_widget_updatesoptions_widget_title">Title<input id="fdw_widget_updatesoptions_widget_title" name="fdw_widget_updatesoptions_widget_title" type="text" value="' . $title . '" /></label></p>
			<p style="text-align:right;"><label for="fdw_widget_updatesoptions_widget_width">Number to show<input id="fdw_widget_updatesoptions_widget_width" name="fdw_widget_updatesoptions_widget_num" type="text" value="' . $num . '" /></label></p>
			<input type="hidden" id="fdw_widget_updatesoptions_action" name="fdw_widget_updatesoptions_action" value="fdw_widget_updatesoptions_update_widget_options" />
		');
	}
	register_widget_control('Facebook Status Updates', 'fdw_updates_widget_control', 200, 100);
	
	function fdw_notifications_widget_control() {
		$options = get_option('fdw_widget_notificationsoptions');
		if (!is_array($options)) {
			$options = array(
				'title'	=> 'Facebook Notifications',
				'num'	=> '5'
			);
		}
		if (isset($_POST['fdw_widget_notificationsoptions_action']) && $_POST['fdw_widget_notificationsoptions_action'] == 'fdw_widget_notificationsoptions_update_widget_options') {
			$options['title']	= sprintf('%s', $_POST['fdw_widget_notificationsoptions_widget_title']);
			$options['num']		= sprintf('%d', $_POST['fdw_widget_notificationsoptions_widget_num']);
			update_option('fdw_widget_notificationsoptions', $options);
		}
		
		$title	= $options['title'];
		$num	= $options['num'];
		print('
			<p style="text-align:right;"><label for="fdw_widget_notificationsoptions_widget_title">Title<input id="fdw_widget_notificationsoptions_widget_title" name="fdw_widget_notificationsoptions_widget_title" type="text" value="' . $title . '" /></label></p>
			<p style="text-align:right;"><label for="fdw_widget_notificationsoptions_widget_width">Number to show<input id="fdw_widget_notificationsoptions_widget_width" name="fdw_widget_notificationsoptions_widget_num" type="text" value="' . $num . '" /></label></p>
			<input type="hidden" id="fdw_widget_notificationsoptions_action" name="fdw_widget_notificationsoptions_action" value="fdw_widget_notificationsoptions_update_widget_options" />
		');
	}
	register_widget_control('Facebook Notifications', 'fdw_notifications_widget_control', 200, 100);
	
	function fdw_posteditems_widget_control() {
		$options = get_option('fdw_widget_posteditemsoptions');
		if (!is_array($options)) {
			$options = array(
				'title'	=> 'Facebook Posted Items',
				'num'	=> '5'
			);
		}
		if (isset($_POST['fdw_widget_posteditemsoptions_action']) && $_POST['fdw_widget_posteditemsoptions_action'] == 'fdw_widget_posteditemsoptions_update_widget_options') {
			$options['title']	= sprintf('%s', $_POST['fdw_widget_posteditemsoptions_widget_title']);
			$options['num']		= sprintf('%d', $_POST['fdw_widget_posteditemsoptions_widget_num']);
			update_option('fdw_widget_posteditemsoptions', $options);
		}
		
		$title	= $options['title'];
		$num	= $options['num'];
		print('
			<p style="text-align:right;"><label for="fdw_widget_posteditemsoptions_widget_title">Title<input id="fdw_widget_posteditemsoptions_widget_title" name="fdw_widget_posteditemsoptions_widget_title" type="text" value="' . $title . '" /></label></p>
			<p style="text-align:right;"><label for="fdw_widget_posteditemsoptions_widget_width">Number to show<input id="fdw_widget_posteditemsoptions_widget_width" name="fdw_widget_posteditemsoptions_widget_num" type="text" value="' . $num . '" /></label></p>
			<input type="hidden" id="fdw_widget_posteditemsoptions_action" name="fdw_widget_posteditemsoptions_action" value="fdw_widget_posteditemsoptions_update_widget_options" />
		');
	}
	register_widget_control('Facebook Posted Items', 'fdw_posteditems_widget_control', 200, 100);
}

add_action('widgets_init', 'fdw_sidebar');

?>